//Ionic Starter App

//angular.module is a global place for creating, registering and retrieving Angular modules
//'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
//the 2nd parameter is an array of 'requires'
//'starter.controllers' is found in controllers.js
angular.module('wikiStarter', ['ionic', 'wikiStarter.controllers'])

.run(function($ionicPlatform,$ionicPopup) {
	$ionicPlatform.ready(function() {
		// Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
		// for form inputs)
		if (window.cordova && window.cordova.plugins.Keyboard) {
			cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
		}
		if (window.StatusBar) {
			// org.apache.cordova.statusbar required
			StatusBar.styleDefault();
		}
		
		//Google Analytics
        if(typeof analytics !== 'undefined') {
            analytics.startTrackerWithId("UA-62214168-2");
        } else {
            console.log("Google Analytics Unavailable");
        }
		
		// Detect AdMob
		if(typeof AdMob !== 'undefined') {
			// Detect platform    
			var admobid = {};
		    if( /(android)/i.test(navigator.userAgent) ) { // for android
		        admobid = {
		            banner: "ca-app-pub-9371401556810759/4199347821", // or DFP format "/6253334/dfp_example_ad"
		            interstitial: "ca-app-pub-9371401556810759/4195687827"
		        };
		    } else if(/(ipod|iphone|ipad)/i.test(navigator.userAgent)) { // for ios
		        admobid = {
		            banner: '', // or DFP format "/6253334/dfp_example_ad"
		            interstitial: ''
		        };
		    } else { // for windows phone
		        admobid = {
		            banner: "ca-app-pub-9371401556810759/4199347821", // or DFP format "/6253334/dfp_example_ad"
		            interstitial: "ca-app-pub-9371401556810759/4195687827"
		        };
		    }
		    
			// Create banner
			AdMob.createBanner({
			adId: admobid.banner, 
			position: AdMob.AD_POSITION.BOTTOM_CENTER,
			isTesting: false,
			autoShow: true });

			// Create interstitial
			AdMob.prepareInterstitial({
				adId:admobid.interstitial,
				isTesting: false,
				autoShow:false });
		}else{
			console.log("AdMob Unavailable");
		}
	
	});
})

.config(function($stateProvider, $urlRouterProvider) {
	$stateProvider

	.state('app', {
		url: "/app",
		abstract: true,
		templateUrl: "templates/menu.html",
		controller: 'AppCtrl'
	})

	.state('app.welcome', {
		url: "/welcome",
		views: {
			'menuContent': {
				templateUrl: "templates/welcome.html",
				controller: 'welcomeCtrl'
			}
		}
	})
	
	.state('app.about', {
		url: "/about",
		views: {
			'menuContent': {
				templateUrl: "templates/about.html",
				controller: 'aboutCtrl'
			}
		}
	})

	.state('app.search', {
		url: "/search",
		views: {
			'menuContent': {
				templateUrl: "templates/search.html",
				controller: 'searchCtrl'
			}
		}
	})

	.state('app.browse', {
		url: "/browse/:menuId",
		views: {
			'menuContent': {
				templateUrl: "templates/browse.html",
				controller: 'browseCtrl'
			}
		}
	})

	.state('app.articles', {
		url: "/articles",
		views: {
			'menuContent': {
				templateUrl: "templates/articles.html",
				controller: 'articlesCtrl'
			}
		}
	})

	.state('app.article', {
		url: "/article/:articleId",
		views: {
			'menuContent': {
				templateUrl: "templates/article.html",
				controller: 'articleCtrl'
			}
		}
	})


	.state('app.skill_list', {
		url: "/skill_list/:filename",
		views: {
			'menuContent': {
				templateUrl: "templates/skill_list.html",
				controller: 'listCtrl'
			}
		}
	})

	.state('app.zsoul_list', {
		url: "/zsoul_list/:filename",
		views: {
			'menuContent': {
				templateUrl: "templates/zsoul_list.html",
				controller: 'listCtrl'
			}
		}
	})

	.state('app.image', {
		url: "/image/:imageSource/title/:imageTitle",
		views: {
			'menuContent': {
				templateUrl: "templates/image_view.html",
				controller: 'imageCtrl'
			}
		}
	});


	// if none of the above states are matched, use this as the fallback
	$urlRouterProvider.otherwise('/app/welcome');
});
