angular.module('wikiStarter.controllers', [])

.controller('AppCtrl', function($ionicPopup,$scope,$rootScope, $log, $http, $location, $ionicModal, $timeout) {
	$rootScope.go = function ( path ) {
		  $location.path( path );
	};
	
	$rootScope.increaseCounter = function () {
		if ($rootScope.counter == undefined) $rootScope.counter = 0;
		$rootScope.counter = $rootScope.counter + 1;
		// show the interstitial if more than 10 pages have been visited
		if (typeof AdMob !== 'undefined' && $rootScope.counter>=10 && $rootScope.showAd) {			
			// check and show the interstitial
			AdMob.isInterstitialReady(function(isready){
				if(isready) {
					AdMob.showInterstitial();
					$rootScope.showAd = false;
				}
			});
		}
	};
	
	//Loads the data from the data.json
	$rootScope.loadData = function (callback) {
		$http.get("data/data.json").success(function(response) {
			$rootScope.data = response.content;
			if (callback !=undefined){
				callback();
			}
		});
		$rootScope.counter = 0;
		$rootScope.showAd = true;
	}

	// function that loads the data and call the callback
	$rootScope.init = function(callback) {
		if ($rootScope.data == undefined) {
		    $rootScope.loadData(function() {if (callback !=undefined){callback();}});
		}else{
		    if (callback !=undefined){
				callback();
			}
		}		
	}
	
    // An alert dialog
    $rootScope.showPopup = function(title,text) {
      var alertPopup = $ionicPopup.alert({
        title: title,
		cssClass:'popup',
		// subTitle: 'Please use normal things',
        template: text,
		    buttons: [
			{ text: 'Close' ,type: 'button-assertive'}
			]
      });
      alertPopup;
    };
	
	$rootScope.getMenuIndex = function (menu,array) {
		var i = 0;
		while (array[i].menutitle != menu && i < array.length){
			i = i+1;
		}
		return i;
	}
	
	$rootScope.getContentFromId = function (articleId,array) {
		var object = {};
		var boolean = false;
		var i=0;
		
		while ((i<array.length) && !boolean){
			if (array[i].content){
				if (array[i].id == articleId){
					object = array[i];
					boolean = true;
				}else{
					var result = $rootScope.getContentFromId(articleId,array[i].content);
					if (result[1]){
						object = result[0];
						boolean = result[1];
					}
				}			
			}else{
				if (array[i].id == articleId){
					object = array[i];
					boolean = true;
				}
			}
			i=i+1;			
		}
		return [object,boolean];
	}
})

.controller('welcomeCtrl', function($scope,$rootScope,$log) {
	$rootScope.loadData(function() {});
	
    if(typeof analytics !== 'undefined') {
        analytics.trackView('Home');
    } 
})

.controller('searchCtrl', function($scope,$rootScope,$log) {

    if(typeof analytics !== 'undefined') {
        analytics.trackView('Search');
    } 
	
	$rootScope.increaseCounter();
	
	$scope.input = {}

	$scope.filterExpression = function(menu) {
		return ($scope.input.search!="" && menu.title.toLowerCase().indexOf($scope.input.search.toLowerCase()) > -1 || menu.content);
	}
	
	$scope.clearSearch = function() {
		$rootScope.init(function() {});	
		$scope.input.search = "";
	}
})


.controller('browseCtrl', function($scope,$rootScope,$log,$stateParams,$filter) {
	$scope.init = function() {
		$rootScope.init($scope.setBrowseContent);	
	}
	
	$scope.setBrowseContent = function() {		
		$rootScope.increaseCounter();		
		if ($stateParams.menuId == 'main'){
			$scope.browseContent = $rootScope.data;
			$scope.browseTitle = "Browse";
		}else{
			var contentObject = $rootScope.getContentFromId($stateParams.menuId,$rootScope.data);
			if (contentObject[1]){				
				$scope.browseContent = contentObject[0].content;
				$scope.browseTitle = contentObject[0].title;
				
	            if(typeof analytics !== 'undefined') {
	                analytics.trackView($scope.browseTitle);
	            } 
				
			}else{
				$scope.browseContent = $rootScope.data;
				$scope.browseTitle = "Browse";
			}		
		}
	}
})

.controller('articlesCtrl', function($scope,$rootScope,$log) {
	$scope.init = function() {
		$rootScope.init(function() {});	
	}
	$rootScope.increaseCounter();
})

.controller('aboutCtrl', function($scope,$rootScope,$log) {
    if(typeof analytics !== 'undefined') {
        analytics.trackView('About');
    } 
	$rootScope.increaseCounter();
})

.controller('articleCtrl', function($scope, $rootScope, $stateParams, $log, $filter, $window, $location) {
	$scope.init = function() {
		$rootScope.init($scope.setContent);
		if ($rootScope.zsoulPopup !== undefined){
			$rootScope.zsoulPopup.close();
		}
	}

	$scope.setContent = function() {
	    var contentObject = $rootScope.getContentFromId($stateParams.articleId,$rootScope.data);
        $scope.contentToView={};
        if (contentObject[1]){
            $scope.contentToView.title = contentObject[0].title;
            $scope.contentToView.source = "data/" + contentObject[0].path;
            if(typeof analytics !== 'undefined') {
                analytics.trackView($scope.contentToView.title);
            }
			$rootScope.increaseCounter();
        }else{
            $scope.contentToView.title = "Not Found";
            $scope.contentToView.source = "data/empty.html";
        }
	}

})

.controller('listCtrl', function($scope, $rootScope, $stateParams, $log, $filter, $window, $location, $http, $ionicPopup) {
	$scope.init = function() {
		$rootScope.init($scope.setContent);	
	}

	$scope.setContent = function() {
		$scope.pageData={};
		$http.get("data/json/"+$stateParams.filename+".json").success(function(response) {
			$scope.pageData = response;
			if(typeof analytics !== 'undefined') {
                analytics.trackView($scope.pageData.title);
            }
		});
	}

    $scope.showSkillPopup = function(name,race,use_cost,description) {
		var text = "<b>Usable by:</b> " + race +"<br><hr><b>Use Cost:</b> " + use_cost + "<br><hr><b>Description:</b> "+description;		
		var skillPopup = $ionicPopup.alert({
			title: name,
			cssClass:'popup',
			template: text,
			okText: 'OK',
			okType:'button-assertive'
		});
		skillPopup;
	};

	$scope.formatStats = function(text) {
		result = text.replace(/ /g,"<br>")
		return result;
	};

	$scope.showZsoulPopup = function(name,activation,effect,location) {
		var text = "<b>Obtained Via:</b> "+location + "<br><hr><b>Activation:</b> " + activation + "<br><hr><b>Effect:</b> "+effect;		
		$rootScope.zsoulPopup = $ionicPopup.alert({
			title: name,
			cssClass:'popup',
			template: text,
			okText: 'OK',
			okType:'button-assertive'
		});
		$rootScope.zsoulPopup;		
	};
})

.controller('imageCtrl', function($scope, $rootScope, $stateParams, $log, $filter, $window, $location) {
	$scope.init = function() {
		$rootScope.init($scope.setContent);	
	}

	$scope.setContent = function() {
		$rootScope.increaseCounter();
        $scope.contentToView={};
        $scope.contentToView.title = $stateParams.imageTitle;
        $scope.contentToView.source = "./data/icons/clothing/" + $stateParams.imageSource + ".jpg";
	}
});
